Package org.jbpm.services.ejb.impl

## Class DeploymentServiceEJBImpl

- java.lang.Object
- - org.jbpm.kie.services.impl.AbstractDeploymentService
  - - org.jbpm.kie.services.impl.KModuleDeploymentService
    - - org.jbpm.services.ejb.impl.DeploymentServiceEJBImpl

- All Implemented Interfaces:
    `DeploymentService`, `ListenerSupport`, `DeploymentServiceEJBLocal`, `DeploymentServiceEJBRemote`

      public class DeploymentServiceEJBImpl
      extends KModuleDeploymentService
      implements ListenerSupport, DeploymentService, DeploymentServiceEJBLocal, DeploymentServiceEJBRemote

- - ### Field Summary

    - ### Fields inherited from class org.jbpm.kie.services.impl.KModuleDeploymentService

      `bpmn2Service, caseIdXPathExpression, executorService, formManagerService, logger, merger, processIdXPathExpression`

    - ### Fields inherited from class org.jbpm.kie.services.impl.AbstractDeploymentService

      `deploymentsMap, emf, listeners, managerFactory, runtimeDataService`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DeploymentServiceEJBImpl()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `addAsyncHandler​(KModuleDeploymentUnit unit)` |
    `void` | `deploy​(String groupId, String artifactId, String version)` | Deploys artifact identified by given GAV (group, artifact, version)
    `void` | `deploy​(String groupId, String artifactId, String version, String kbaseName, String ksessionName)` | Deploys artifact identified by given GAV (group, artifact, version) with additional selection of kbase and ksession names from kmodule.xml - these names must exists in kmodule.xml of the artifact being deployed
    `void` | `deploy​(String groupId, String artifactId, String version, String kbaseName, String ksessionName, String strategy)` | Deploys artifact identified by given GAV (group, artifact, version) with additional selection of kbase and ksession names from kmodule.xml - these names must exists in kmodule.xml of the artifact being deployed and runtime strategy (singleton, per request, per process instance)
    `void` | `deploy​(DeploymentUnit unit)` | Performs deployment operation of given `unit`.
    `protected boolean` | `isExecutorOnClasspath()` |
    `void` | `onInit()` |
    `void` | `setBpmn2Service​(DefinitionService bpmn2Service)` |
    `void` | `setContext​(javax.ejb.EJBContext context)` |
    `void` | `setEmf​(javax.persistence.EntityManagerFactory emf)` |
    `void` | `setExecutorService​(org.kie.api.executor.ExecutorService executorService)` |
    `void` | `setFormManagerService​(FormManagerService formManagerService)` |
    `void` | `setRuntimeDataService​(RuntimeDataService runtimeDataService)` |
    `void` | `shutdown()` |
    `void` | `undeploy​(String deploymentId)` | Undeploys currently active deployment unit identified by given deploymentId
    `void` | `undeploy​(String deploymentId, Function<DeploymentUnit,​Boolean> beforeUndeploy)` | Undeploys currently active deployment unit identified by given deploymentId

    - ### Methods inherited from class org.jbpm.kie.services.impl.KModuleDeploymentService

      `activate, addClassToDeployedUnit, boostrapRuntimeEnvironmentBuilder, buildContextParameters, deactivate, getCaseId, getInstanceFromModel, getProcessId, getRegisterableItemsFactory, processClassloader, processResources, setMerger, undeploy`

    - ### Methods inherited from class org.jbpm.kie.services.impl.AbstractDeploymentService

      `addListener, commonDeploy, getDeployedUnit, getDeployedUnits, getDeploymentsMap, getEmf, getListeners, getManagerFactory, getRuntimeDataService, getRuntimeManager, isDeployed, notifyOnActivate, notifyOnDeactivate, notifyOnDeploy, notifyOnUnDeploy, removeListener, setIdentityProvider, setManagerFactory, setupAuditLogger, undeploy`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.jbpm.services.api.DeploymentService

      `activate, deactivate, getDeployedUnit, getDeployedUnits, getRuntimeManager, isDeployed, undeploy, undeploy`

    - ### Methods inherited from interface org.jbpm.services.ejb.api.DeploymentServiceEJBRemote

      `activate, deactivate, isDeployed`

    - ### Methods inherited from interface org.jbpm.services.api.ListenerSupport

      `addListener, getListeners, removeListener`

- - ### Constructor Detail

    - #### DeploymentServiceEJBImpl

          public DeploymentServiceEJBImpl()

  - ### Method Detail

    - #### onInit

          @PostConstruct
          public void onInit()

      Overrides:
        `onInit` in class `KModuleDeploymentService`

    - #### shutdown

          @PreDestroy
          public void shutdown()

      Overrides:
        `shutdown` in class `AbstractDeploymentService`

    - #### setContext

          public void setContext​(javax.ejb.EJBContext context)

    - #### setEmf

          public void setEmf​(javax.persistence.EntityManagerFactory emf)

      Overrides:
        `setEmf` in class `AbstractDeploymentService`

    - #### setBpmn2Service

          public void setBpmn2Service​(DefinitionService bpmn2Service)

      Overrides:
        `setBpmn2Service` in class `KModuleDeploymentService`

    - #### setRuntimeDataService

          public void setRuntimeDataService​(RuntimeDataService runtimeDataService)

      Overrides:
        `setRuntimeDataService` in class `AbstractDeploymentService`

    - #### setFormManagerService

          public void setFormManagerService​(FormManagerService formManagerService)

      Overrides:
        `setFormManagerService` in class `KModuleDeploymentService`

    - #### setExecutorService

          public void setExecutorService​(org.kie.api.executor.ExecutorService executorService)

      Overrides:
        `setExecutorService` in class `KModuleDeploymentService`

    - #### deploy

          public void deploy​(String groupId,
                             String artifactId,
                             String version)

      Description copied from interface: `DeploymentServiceEJBRemote`
      Deploys artifact identified by given GAV (group, artifact, version)
      Specified by:
        `deploy` in interface `DeploymentServiceEJBRemote`
      Parameters:
        `groupId` - group id of the artifact to deploy
        `artifactId` - artifact id of the artifact to deploy
        `version` - version of the artifact to deploy

    - #### deploy

          public void deploy​(String groupId,
                             String artifactId,
                             String version,
                             String kbaseName,
                             String ksessionName)

      Description copied from interface: `DeploymentServiceEJBRemote`
      Deploys artifact identified by given GAV (group, artifact, version) with additional selection of kbase and ksession names from kmodule.xml - these names must exists in kmodule.xml of the artifact being deployed
      Specified by:
        `deploy` in interface `DeploymentServiceEJBRemote`
      Parameters:
        `groupId` - group id of the artifact to deploy
        `artifactId` - artifact id of the artifact to deploy
        `version` - version of the artifact to deploy
        `kbaseName` - name of kie base defined in kmodule.xml
        `ksessionName` - name of kie session defined in kmodule.xml

    - #### deploy

          public void deploy​(String groupId,
                             String artifactId,
                             String version,
                             String kbaseName,
                             String ksessionName,
                             String strategy)

      Description copied from interface: `DeploymentServiceEJBRemote`
      Deploys artifact identified by given GAV (group, artifact, version) with additional selection of kbase and ksession names from kmodule.xml - these names must exists in kmodule.xml of the artifact being deployed and runtime strategy (singleton, per request, per process instance)
      Specified by:
        `deploy` in interface `DeploymentServiceEJBRemote`
      Parameters:
        `groupId` - group id of the artifact to deploy
        `artifactId` - artifact id of the artifact to deploy
        `version` - version of the artifact to deploy
        `kbaseName` - name of kie base defined in kmodule.xml
        `ksessionName` - name of kie session defined in kmodule.xml
        `strategy` - selected runtime strategy

    - #### deploy

          public void deploy​(DeploymentUnit unit)

      Description copied from interface: `DeploymentService`
      Performs deployment operation of given `unit`.
      Specified by:
        `deploy` in interface `DeploymentService`
      Overrides:
        `deploy` in class `KModuleDeploymentService`
      Parameters:
        `unit` - deployment unit to be deployed to runtime

    - #### undeploy

          public void undeploy​(String deploymentId)

      Description copied from interface: `DeploymentServiceEJBRemote`
      Undeploys currently active deployment unit identified by given deploymentId
      Specified by:
        `undeploy` in interface `DeploymentServiceEJBRemote`
      Parameters:
        `deploymentId` - unique identifier of the deployment

    - #### undeploy

          public void undeploy​(String deploymentId,
                               Function<DeploymentUnit,​Boolean> beforeUndeploy)

      Description copied from interface: `DeploymentServiceEJBRemote`
      Undeploys currently active deployment unit identified by given deploymentId
      Specified by:
        `undeploy` in interface `DeploymentServiceEJBRemote`
      Parameters:
        `deploymentId` - unique identifier of the deployment
        `beforeUndeploy` - a function to run custom actions before undeploying a given `DeploymentUnit`. It should return if the unit can be undeployed or not determining if the deployment can continue.

    - #### addAsyncHandler

          protected void addAsyncHandler​(KModuleDeploymentUnit unit)

    - #### isExecutorOnClasspath

          protected boolean isExecutorOnClasspath()